/*
 * QuotesView.java
 *
 * Created on 10 de agosto de 2004, 18:07
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;
import java.util.Hashtable;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import java.util.Vector;

import com.fenalco.entities.DataAccess;
import com.fenalco.entities.QuoteList;
import com.fenalco.entities.User;

import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.QuoteListViewSupplier;

/**
 * Este servlet construye la lista de cotizaciones recibidas por un proveedor
 * para que le puedan ser presentadas y pueda ver sus detalles, responderlas o
 * rechazarlas.
 * 
 * @author andres
 */
public class QuotesView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de falla en la operación de inicialización.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método construye un objeto del tipo <CODE>QuoteList</CODE>
	 * utilizando como parámetro el id del proveedor y el identificador de rol
	 * que para este caso es el de proveedor.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
                            
                                // criterios de paginación
				int pagina = 1;
				int resultadosPagina = 20;
				int paginas; // numero total de páginas
				int inicio = 0; // numero del primero registro que se va a mostrar
				int fin = 9; // numero del último registro que se va a mostrar
				int total; // numero total de resultados
                                
                                String temp = request.getParameter("page");
                                if( temp == null ){
                                    
                                    pagina = 1;
                                    
                                }else{
                                
                                    pagina = Integer.parseInt( temp );
                                    
                                }
                                
                                pagina = (pagina < 1)? 1 : pagina;
                                temp = request.getParameter( "numResults" );
                                
                                if( temp == null ){
                                    
                                    resultadosPagina = 20;
                                    
                                }else{
                                
                                    resultadosPagina = Integer.parseInt( temp );
                                    
                                }
                                
                                resultadosPagina = (resultadosPagina < 1)? 20 : resultadosPagina;
                                
                                
                                
				url = "/proveedor/cotizacionesproveedor.jsp";
				User supplier = (User) session.getAttribute("user");
				QuoteList quoteList = new QuoteList(supplier.getCompanyId(),supplier.getRoleId());
                                
                                Vector results = new Vector();
                                total = quoteList.getQuotes().size();  
                                
                                paginas = (int) Math.ceil((double) total / (double) resultadosPagina);
                                
				if( pagina > paginas ){
					pagina = paginas;
				}
                                
				inicio = (pagina - 1) * resultadosPagina;
				fin = pagina * resultadosPagina;
				inicio = (inicio < 0) ? 0 : inicio;
                                
				if( fin > total ){
					fin = total;
				}
                                
				for( int i = inicio; i < fin; i++ ){
					results.addElement( quoteList.getQuotes().elementAt(i) );
                                }
                                
                                quoteList.setQuotes( results ); 
                                
                                
				QuoteListViewSupplier view = new QuoteListViewSupplier(quoteList);
				Hashtable quoteStatus = DataAccess.getQuoteStatus();
	
				if( view == null )
				{
					//Fallo en la creacion del listado de cotizaciones
					message = MessageBuilder.buildMessage(9);
				}
				else
				{
					//Todo OK
					//El listado de cotizaciones se cargo correctamente
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("view", view);
					request.setAttribute("quoteStatus", quoteStatus);
				}
                                
                                /// información de la paginacion
                                 inicio++; // para no arrancar desde 0
                                 inicio = (fin == 0) ? 0 : inicio;
                                 request.setAttribute("inicio", inicio + "");
                                 request.setAttribute("fin", fin + "");
                                 request.setAttribute("total", total + "");
                                 request.setAttribute("pagina", pagina + "");
                                 request.setAttribute("paginas", paginas + "");
                                 request.setAttribute("cantidad", resultadosPagina + "");
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}